package com.winhc.dataworks.flow.touch.service;

import com.aliyun.odps.Instance;
import com.aliyun.odps.Odps;
import com.aliyun.odps.OdpsException;
import com.aliyun.odps.data.Record;
import com.aliyun.odps.task.SQLTask;
import com.helospark.lightdi.annotation.Autowired;
import com.helospark.lightdi.annotation.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @Author: XuJiakai
 * @Date: 2020/7/6 17:52
 * @Description:
 */
@Service
public class OdpsService {

    @Autowired
    private Odps odps;

    public List<String> getNotEmptyTable(String ds) {
        ds = ds.replace("-", "");
        String sql = "SELECT table_name FROM information_schema.PARTITIONS WHERE substring(table_name,1,8) = 'inc_ods_' AND partition_name = 'ds=" + ds + "' and data_length <> 0 ;";
        Instance i;
        List<String> list = new ArrayList<>();
        try {
            i = SQLTask.run(odps, sql);
            i.waitForSuccess();
            List<Record> records = SQLTask.getResult(i);
            for (Record r : records) {
                list.add(r.get(0).toString());
            }
        } catch (OdpsException e) {
            e.printStackTrace();
        }
        return list.stream().map(s -> s.replace("inc_ods_", "")).collect(Collectors.toList());
    }



}
